Index: /trunk/gsdl/perllib/classify.pm
===================================================================
--- /trunk/gsdl/perllib/classify.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify.pm	(revision 10218)
@@ -58,6 +58,5 @@
     my ($classobj);
     my $options = "-gsdlinfo";
-
-    eval ("\$classobj = new \$classifier($options)");
+    eval ("\$classobj = new \$classifier([],[$options])");
     die "$@" if $@;
 
@@ -112,5 +111,6 @@
 	my $options .= join (",", @newoptions);
 
-	eval ("\$classobj = new \$classname($options)");
+
+	eval ("\$classobj = new \$classname([],[$options])");
 	die "$@" if $@;
 
Index: /trunk/gsdl/perllib/classify/AZCompactList.pm
===================================================================
--- /trunk/gsdl/perllib/classify/AZCompactList.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/AZCompactList.pm	(revision 10218)
@@ -62,5 +62,5 @@
 	'desc' => "{AZCompactList.sort}",
 	'type' => "string",
-	'deft' => "Title",
+#	'deft' => "Title",
 	'reqd' => "no" },
       { 'name' => "removeprefix",
@@ -121,52 +121,14 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasClas($class, @_);
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-	return bless $self, $class;
-    }
-
-    my ($metaname, $title, $removeprefix, $removesuffix);
-    my $sortname = "Title";
-    my $mingroup = 2;
-    my $minnesting = 20;
-    my $mincompact = 10;
-    my $maxcompact = 30;
-    my $doclevel = "top";
-    my $firstvalueonly = 0;
-    my $allvalues = 0;
-    my $freqsort = 0;
-    my $recopt   = undef;
-
-    if (!parsargv::parse(\@_, 
-			 q^metadata/.*/^, \$metaname,
-			 q^buttonname/.*/^, \$title,
-			 q^sort/.*/^, \$sortname,
-			 q^removeprefix/.*/^, \$removeprefix,
-			 q^removesuffix/.*/^, \$removesuffix,
-			 q^mingroup/.*/2^, \$mingroup,
-			 q^minnesting/.*/20^, \$minnesting,
-			 q^mincompact/.*/10^, \$mincompact,
-			 q^maxcompact/.*/30^, \$maxcompact,
-			 q^doclevel/.*/top^, \$doclevel,
-			 q^firstvalueonly^, \$firstvalueonly,
-			 q^allvalues^, \$allvalues,
-			 q^freqsort/.*/0^, \$freqsort,
-			 q^recopt/.*/-1^, \$recopt,  # Used in nested metadata such as -metadata Year/Organisation
-
-			 "allow_extra_options")) {
-	
-	print STDERR "\nIncorrect options passed to $class, check your collect.cfg file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
-    if (!defined($metaname)) {
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasClas($pluginlist,$inputargs,$hashArgOptLists): new BasClas($pluginlist,$inputargs);
+
+    if (!$self->{"metadata"}) {
 	my $outhandle = $self->{'outhandle'};
 	print $outhandle "AZCompactList Error: required option -metadata not supplied\n";
@@ -175,7 +137,5 @@
     }
 
-    $title = $self->generate_title_from_metadata($metaname) unless ($title);
-    #$title = $metaname unless ($title);
-
+    # Manually set $self parameters.
     $self->{'list'} = {};
     $self->{'listmetavalue'} = {};
@@ -183,42 +143,19 @@
     $self->{'reclassify'} = {};
     $self->{'reclassifylist'} = {};
-    $self->{'metaname'} = $metaname;
-    $self->{'title'} = "$title";     # title for the titlebar.
-    $self->{'sortname'} = $sortname;
-
-    if (defined($removeprefix) && $removeprefix) {
-	$removeprefix =~ s/^\^//; # don't need a leading ^
-	$self->{'removeprefix'} = $removeprefix;
-    }
-    if (defined($removesuffix) && $removesuffix) {
-	$removesuffix =~ s/\$$//; # don't need a trailing $
-	$self->{'removesuffix'} = $removesuffix;
-    }
-    $self->{'mingroup'} = $mingroup;
-    $self->{'minnesting'} = $minnesting;
-    $self->{'mincompact'} = $mincompact;
-    $self->{'maxcompact'} = $maxcompact;
-    $self->{'doclevel'} = $doclevel;
-
-    if ($firstvalueonly != 0) {
-	$firstvalueonly = 1;
-    }
-    $self->{'firstvalueonly'} = $firstvalueonly;
-  
-    if ($allvalues != 0) {
-	$allvalues = 1;
-    }
-    $self->{'allvalues'} = $allvalues;
-    if ($freqsort != 0) {
-	$freqsort = 1;
-    }
-    $self->{'freqsort'} = $freqsort;
-
-    if ($recopt == -1) {
-	$recopt = undef; 
-    } else {
-	$recopt = "on";
-    }
-    $self->{'recopt'} = $recopt;
+
+    $self->{'buttonname'} = $self->generate_title_from_metadata($self->{'metadata'}) unless ($self->{'buttonname'});
+    
+    if (defined($self->{"removeprefix"}) && $self->{"removeprefix"}) {
+	$self->{"removeprefix"} =~ s/^\^//; # don't need a leading ^
+    }
+    if (defined($self->{"removesuffix"}) && $self->{"removesuffix"}) {
+	$self->{"removesuffix"} =~ s/\$$//; # don't need a trailing $
+    }
+	
+    $self->{'recopt'} = ($self->{'recopt'} == 0) ? undef : "on";
+
+    # Clean out the unused keys
+    if($self->{"removeprefix"} eq "") {delete $self->{"removeprefix"};}
+    if($self->{"removesuffix"} eq "") {delete $self->{"removesuffix"};}
 
     return bless $self, $class;
@@ -247,5 +184,5 @@
     my @sectionlist = ();
     my $topsection = $doc_obj->get_top_section();
-    my $metaname = $self->{'metaname'};
+    my $metaname = $self->{'metadata'};
     my $outhandle = $self->{'outhandle'};
 
@@ -317,5 +254,5 @@
 
 		my $formatted_metavalue =
-		  sorttools::format_metadata_for_sorting($self->{'metaname'},
+		  sorttools::format_metadata_for_sorting($self->{'metadata'},
 							 $metavalue, $doc_obj);
 		
@@ -338,5 +275,5 @@
 
 	# This is used in reclassify below for AZCompactSectionList
-	my $sortmeta = $doc_obj->get_metadata_element($thissection, $self->{'sortname'});
+	my $sortmeta = $doc_obj->get_metadata_element($thissection, $self->{'sort'});
 	$self->{'reclassify'}->{$full_doc_OID} = [$doc_obj,$sortmeta];
     }
@@ -413,5 +350,5 @@
     my $doclevel = $self->{'doclevel'};
     my $mingroup = $self->{'mingroup'};
-    my @metaname_list = split(/\/|\|/,$self->{'metaname'});
+    my @metaname_list = split(/\/|\|/,$self->{'metadata'});
     my $metaname = shift(@metaname_list);
     my $hierarchical = 0;
@@ -433,15 +370,14 @@
 		# buttonname is also used for the node's title
 		push @args, ("-buttonname", "$metavalue");
-		push @args, ("-sort", $self->{'sortname'});
-
+		push @args, ("-sort", $self->{'sort'});
+
+		my $ptArgs = \@args;
 		if ($doclevel =~ m/^top(level)?/i)
 		{
-		    eval ("\$listclassobj = new List(\@args)"); 
-		    warn $@ if $@;
+		    eval ("\$listclassobj = new List([],\$ptArgs)"); 
 		}
 		else
 		{
-		    eval ("\$listclassobj = new SectionList(\@args)"); 
-		    warn $@ if $@;
+		    eval ("\$listclassobj = new SectionList([],\$ptArgs)");
 		}
 	    }
@@ -453,5 +389,5 @@
 		# buttonname is also used for the node's title
 		push @args, ("-buttonname", "$metavalue");
-		push @args, ("-sort", $self->{'sortname'});
+		push @args, ("-sort", $self->{'sort'});
 
 		if (defined $self->{'removeprefix'}) {
@@ -466,7 +402,8 @@
 		push @args, "-recopt ";
 
-		eval ("\$listclassobj = new AZCompactList(\@args)");
-		warn $@ if $@;
-	    }
+		my $ptArgs = \@args;
+		eval ("\$listclassobj = new AZCompactList([],\$ptArgs)");
+	    }
+	    
 	    if ($@) {
 		print $outhandle "$@";
@@ -493,5 +430,5 @@
 		}
 
-		$formatted_node = &sorttools::format_metadata_for_sorting($self->{'metaname'}, $formatted_node); 
+		$formatted_node = &sorttools::format_metadata_for_sorting($self->{'metadata'}, $formatted_node); 
 
 		# In case our formatted string is empty...
@@ -671,5 +608,4 @@
     my $self = shift (@_);
     my ($title, $childtype, $metaname, $thistype) = @_;
-
     # organise into classification structure
     my %classifyinfo = ('childtype'=>$childtype,
@@ -694,5 +630,5 @@
 
     # top level
-    my @metanames = split(/\/|\|/,$self->{'metaname'});
+    my @metanames = split(/\/|\|/,$self->{'metadata'});
     my $metaname = shift(@metanames);
 
@@ -700,9 +636,8 @@
     $childtype = "VList" if (scalar (@$classlistref) <= $self->{'minnesting'});
 
+    my $title = $self->{'buttonname'}; # should always be defined by now.
     my $classifyinfo;
     if (!defined($self->{'recopt'}))
     {
-	my $title = $self->{'title'}; # should always be defined by now....
-	$title = $metaname unless defined $title; 
 	$classifyinfo 
 	    = $self->get_entry ($title, $childtype, $metaname, "Invisible");
@@ -710,5 +645,4 @@
     else
     {
-	my $title = $self->{'title'};
 	$classifyinfo 
 	    = $self->get_entry ($title, $childtype, $metaname, "VList");
Index: /trunk/gsdl/perllib/classify/AZCompactSectionList.pm
===================================================================
--- /trunk/gsdl/perllib/classify/AZCompactSectionList.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/AZCompactSectionList.pm	(revision 10218)
@@ -23,15 +23,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new AZCompactList($class, @_);
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    #if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-    #return bless $self, $class;
-    #}
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new AZCompactList($classifierslist,$inputargs,$hashArgOptLists): new AZCompactList($classifierslist,$inputargs);
 
     return bless $self, $class;
@@ -117,9 +114,10 @@
 # buttonname is also used for the node's title
 		push @args, ("-buttonname", "$metavalue");
-		push @args, ("-sort", $self->{'sortname'});
-
+		push @args, ("-sort", $self->{'sort'});
+
+		my $ptArgs = \@args;
 		if ($doclevel =~ m/^top(level)?/i)
 		{
-		    eval ("\$listclassobj = new List(\@args)"); warn $@ if $@;
+		    eval ("\$listclassobj = new List([],\$ptArgs)"); warn $@ if $@;
 		}
 		else
@@ -127,5 +125,5 @@
 		    # SECTIONFIX?
 		    #eval ("\$listclassobj = new SectionList($args)");
-		    eval ("\$listclassobj = new SectionList(\@args)");
+		    eval ("\$listclassobj = new SectionList([],\$ptArgs)");
 		}
 	    }
@@ -143,5 +141,6 @@
 		# SECTIONFIX?
 		#eval ("\$listclassobj = new AZCompactList($args)");
-		eval ("\$listclassobj = new AZCompactList(\@args)");
+		my $ptArgs = \@args;
+		eval ("\$listclassobj = new AZCompactList([],\$ptArgs)");
 	    }
 	    if ($@) {
Index: /trunk/gsdl/perllib/classify/AZList.pm
===================================================================
--- /trunk/gsdl/perllib/classify/AZList.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/AZList.pm	(revision 10218)
@@ -67,29 +67,14 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasClas($class, @_);
-    
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-    
-    if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-	return bless $self, $class;
-    }
-    my ($metadata, $title, $removeprefix, $removesuffix);
-    
-    if (!parsargv::parse(\@_, 
-			 q^metadata/.*/^, \$metadata,
-			 q^buttonname/.*/^, \$title,
-			 q^removeprefix/.*/^, \$removeprefix,
-			 q^removesuffix/.*/^, \$removesuffix,
-			 "allow_extra_options")) {
-	
-	print STDERR "\nIncorrect options passed to $class, check your collect.cfg file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
-    if (!$metadata) {
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasClas($classifierslist,$inputargs,$hashArgOptLists): new BasClas($classifierslist,$inputargs);
+
+    if (!$self->{"metadata"}) {
 	print STDERR "AZList Error: required option -metadata not supplied \n";
 	$self->print_txt_usage("");  # Use default resource bundle
@@ -97,22 +82,27 @@
 	die "AZList Error: required option -metadata not supplied\n";
     }
-    
-    my @meta_list = split(/,/, $metadata);
-    #my $meta1 = $meta_list[0];
-
-    #$title = $meta1 unless ($title);
-    $title = $self->generate_title_from_metadata($metadata) unless ($title);
+        
+    # Manually set $self parameters.
     $self->{'list'} = {};
+
+    # Transfer value from Auto Parsing to the variavle name that used in previous GreenStone.
+    my @meta_list = split(/,/, $self->{"metadata"});
     $self->{'meta_list'} = \@meta_list;
-    $self->{'title'} = $title;
-    
-    if (defined($removeprefix) && $removeprefix) {
-	$removeprefix =~ s/^\^//; # don't need a leading ^
-	$self->{'removeprefix'} = $removeprefix;
-    }
-    if (defined($removesuffix) && $removesuffix) {
-	$removesuffix =~ s/\$$//; # don't need a trailing $
-	$self->{'removesuffix'} = $removesuffix;
-    }
+
+    $self->{'buttonname'} = $self->generate_title_from_metadata($self->{'metadata'}) unless ($self->{'buttonname'});
+
+    # Further setup 
+    if (defined($self->{"removeprefix"}) && $self->{"removeprefix"}) {
+	$self->{"removeprefix"} =~ s/^\^//; # don't need a leading ^
+    }
+    if (defined($self->{"removesuffix"}) && $self->{"removesuffix"}) {
+	$self->{"removesuffix"} =~ s/\$$//; # don't need a trailing $
+    }
+
+    # Clean out the unused keys
+    delete $self->{"metadata"}; # Delete this key
+
+    if($self->{"removeprefix"} eq "") {delete $self->{"removeprefix"};}
+    if($self->{"removesuffix"} eq "") {delete $self->{"removesuffix"};}
 
     return bless $self, $class;
@@ -233,5 +223,5 @@
     my $childtype = "HList";
     if (scalar (@$classlistref) <= 39) {$childtype = "VList";}
-    my $classifyinfo = $self->get_entry ($self->{'title'}, $childtype, "Invisible");
+    my $classifyinfo = $self->get_entry ($self->{'buttonname'}, $childtype, "Invisible");
 
     # don't need to do any splitting if there are less than 39 (max + min -1) classifications
Index: /trunk/gsdl/perllib/classify/AZSectionList.pm
===================================================================
--- /trunk/gsdl/perllib/classify/AZSectionList.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/AZSectionList.pm	(revision 10218)
@@ -52,15 +52,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new AZList($class, @_);
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
 
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-    
-    #if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-    #	return bless $self, $class;
-    #}
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new AZList($classifierslist,$inputargs,$hashArgOptLists): new AZList($classifierslist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/classify/AllList.pm
===================================================================
--- /trunk/gsdl/perllib/classify/AllList.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/AllList.pm	(revision 10218)
@@ -15,9 +15,16 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self  = new BasClas($class, @_);
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
 
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasClas($classifierslist,$inputargs,$hashArgOptLists): new BasClas($classifierslist,$inputargs);
+
+    # Manually set $self parameters.
     $self->{'list'} = [];
-    $self->{'title'} = "All Documents";
+    $self->{'buttonname'} = "All Documents";
 
     return bless $self, $class;
@@ -44,5 +51,5 @@
 
     my %classifyinfo = ('childtype'   =>'VList',
-			'Title'       =>$self->{'title'},
+			'Title'       =>$self->{'buttonname'},
 			'contains'    =>[],
 			'classifyOID' =>"oai");
@@ -56,5 +63,5 @@
        
 	my %tempinfo=('childtype'=>'VList',
-		      'Title'=>$self->{'title'},
+		      'Title'=>$self->{'buttonname'},
 		      'classifyOID' =>"oai.$seqNo",
 		      'contains'    =>[]);
Index: /trunk/gsdl/perllib/classify/BasClas.pm
===================================================================
--- /trunk/gsdl/perllib/classify/BasClas.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/BasClas.pm	(revision 10218)
@@ -56,5 +56,5 @@
 use gsprintf;
 use printusage;
-
+use parse2;
 
 my $arguments = 
@@ -67,9 +67,10 @@
 	'type' => "string",
 	'deft' => "STDERR" },
-#      { 'name' => "verbosity",
-#	'desc' => "{BasClas.verbosity}",
+      { 'name' => "verbosity",
+	'desc' => "{BasClas.verbosity}",
 #	'type' => "enum",
-#	'deft' => "2",
-#	'reqd' => "no" } ];
+	'type' => "int",
+	'deft' => "2",
+	'reqd' => "no" },
 #      { 'name' => "ignore_namespace",
 #	'desc' => "{BasClas.ignore_namespace}",
@@ -214,35 +215,61 @@
 
 sub new {
-    my $class = shift (@_);
-    my $name = shift (@_);
-
+    my ($class) = shift (@_);
+    my ($classifierslist,$args,,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
+    my $classifier_name = (defined $classifierslist->[0]) ? $classifierslist->[0] : $class;
+    print STDERR "new $classifier_name\n";
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+
+    # Manually set $self parameters.
     my $self = {};
-
     $self->{'outhandle'} = STDERR;
     $self->{'idnum'} = -1;
-    
-    $self->{'option_list'} = [ $options ];
-    my $gsdlinfo;
-
-    # general options available to all classifiers
-    if (!parsargv::parse(\@_,
-			 q^builddir/.*/^, \$self->{'builddir'},
-			 q^outhandle/.*/STDERR^, \$self->{'outhandle'},
-			 q^verbosity/\d/2^, \$self->{'verbosity'},
-			 q^ignore_namespace^, \$self->{'ignore_namespace'},
-			 q^gsdlinfo^, \$gsdlinfo,
-			 "allow_extra_options")) {
-
-	&gsprintf(STDERR, "\n{BasClas.bad_general_option}\n", $name);
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
-    if ($gsdlinfo) {
-	# created from classinfo.pl - set this so subclasses don't need to 
-	# parse the arguments
-	$self->{'info_only'} = 1;
-    }
-    return bless $self, $class;
+    $self->{'option_list'} = $hashArgOptLists->{"OptList"};
+    $self->{"info_only"} = 0;
+
+    # Check if gsdlinfo is in the argument list or not.  
+    foreach $strArg (@{$args})
+    {
+	if($strArg eq "gsdlinfo")
+	{
+	    $self->{"info_only"} = 1;
+	    last;
+	}
+    }
+
+    # If gsdlinfo is not in the argument list, process the argument normally.
+    if($self->{"info_only"} == 0)
+    {
+	my $blnParseFailed = "false";
+	# general options available to all plugins
+	if(!parse2::parse($args,$hashArgOptLists->{"ArgList"},$self))
+	{
+	    $blnParseFailed = "true"; 
+	}
+	
+	# If the parsing wasn't successful, then print out the text usage of this classifier. 
+	my $classTempClass = bless $self, $class;
+	if($blnParseFailed eq "true")
+	{
+	    &gsprintf(STDERR, "\n{BasClas.bad_general_option}\n", $classifier_name);
+	    $classTempClass->print_txt_usage("");  # Use default resource bundle
+	    die "\n";
+	}
+	else
+	{
+	    delete $self->{"info_only"};
+	    return $classTempClass;
+	}
+    }
+
+    # If gsdlinfo is in the argument list, do not perform any parsing.
+    else
+    {	
+	delete $self->{"info_only"};
+	return bless $self, $class;
+    }
 }
 
Index: /trunk/gsdl/perllib/classify/Browse.pm
===================================================================
--- /trunk/gsdl/perllib/classify/Browse.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/Browse.pm	(revision 10218)
@@ -42,20 +42,16 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasClas($class, @_);
- 
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );  
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
 
-    if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-	return bless $self, $class;
-    }
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
 
-    # classifier information
-    $self->{'collection'} = $ENV{'GSDLCOLLECTION'};
+    my $self = (defined $hashArgOptLists)? new BasClas($classifierslist,$inputargs,$hashArgOptLists): new BasClas($classifierslist,$inputargs);
 
-    $self->{'title'} = "Browse";
+    # Manually set $self parameters.
+    $self->{'collection'} = $ENV{'GSDLCOLLECTION'}; # classifier information
+    $self->{'buttonname'} = "Browse";
 
     return bless $self, $class;
@@ -80,5 +76,5 @@
     # use to create macros when the Phind classifier document is displayed.
     my %classifyinfo = ('thistype'=>'Invisible', 
-                        'Title'=>$self->{'title'},
+                        'Title'=>$self->{'buttonname'},
 			'contains'=>[]);
     
Index: /trunk/gsdl/perllib/classify/Collage.pm
===================================================================
--- /trunk/gsdl/perllib/classify/Collage.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/Collage.pm	(revision 10218)
@@ -106,54 +106,18 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasClas($class, @_);
-
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-	return bless $self, $class;
-    }   
-
-    my ($title, $geometry, $verbosity, $maxDepth, $imageType, $bgcolor, $refreshDelay, $isJava2, $caption, $maxDisplay, $maxDownloads, $list);
-
-    if (!parsargv::parse(\@_, 
-			 q^buttonname/.*/Collage^, \$title,
-			 q^geometry/.*/600x300^, \$geometry,
-			 q^verbosity/.*/3^, \$verbosity,
-			 q^maxDepth/.*/500^, \$maxDepth,
-#			 q^maxDownloads/.*/^, \$maxDownloads,
-			 q^maxDisplay/.*/25^, \$maxDisplay,
-			 q^imageType/.*/.jpg%.png^, \$imageType,
-			 q^bgcolor/.*/\#96c29a^, \$bgcolor,
-			 q^refreshDelay/.*/1200^, \$refreshDelay,
-			 q^isJava2/.*/auto^, \$isJava2,
-			 q^imageMustNotHave/.*/hl=\%x=\%gt=\%gc=\%.pr^, \$imageMustNotHave,
-			 q^caption/.*/ ^, \$caption,
-			 "allow_extra_options")) {
-	
-	print STDERR "\nIncorrect options passed to $class, check your collect.cfg file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
-    if (!$title) {
-	$title = 'Collage';
-    }
-
-    $self->{'list'} = $list;
-    $self->{'title'} = $title;
-    $self->{'geometry'} = $geometry;
-    $self->{'verbosity'} = $verbosity;
-    $self->{'maxDepth'} = $maxDepth;
-    $self->{'maxDownloads'} = $maxDownloads;
-    $self->{'maxDisplay'} = $maxDisplay;
-    $self->{'imageType'} = $imageType;
-    $self->{'bgcolor'} = $bgcolor;
-    $self->{'refreshDelay'} = $refreshDelay;
-    $self->{'isJava2'} = $isJava2;
-#    $self->{'imageMustNotHave'} = $imageMustNotHave;
-    $self->{'caption'} = $caption;
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasClas($classifierslist,$inputargs,$hashArgOptLists): new BasClas($classifierslist,$inputargs);
+
+    # Manually set $self parameters.
+    $self->{'list'} = {};
+    print STDERR "buttonnmae = $buttonname\n";
+    $self->{'buttonname'} = 'Collage' unless ($self->{'buttonname'});
+
     return bless $self, $class;
 }
@@ -206,8 +170,8 @@
 
     if ($verbosity>1) {
-	print $outhandle ("$self->{'title'}\n");
-    }
-
-    my $collage_head = $self->get_entry ($self->{'title'}, "Collage", "Invisible");
+	print $outhandle ("$self->{'buttonname'}\n");
+    }
+
+    my $collage_head = $self->get_entry ($self->{'buttonname'}, "Collage", "Invisible");
     my $collage_curr = $self->get_entry("Collage","VList");
     push (@{$collage_head->{'contains'}},$collage_curr);
Index: /trunk/gsdl/perllib/classify/DateList.pm
===================================================================
--- /trunk/gsdl/perllib/classify/DateList.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/DateList.pm	(revision 10218)
@@ -79,39 +79,20 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasClas($class, @_);
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-	return bless $self, $class;
-    }
-
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasClas($classifierslist,$inputargs,$hashArgOptLists): new BasClas($classifierslist,$inputargs);
+
+    # Manually set $self parameters.
     $self->{'list'} = {};
 
-    my ($datemeta, $sortmeta);
-    $self->{'nogroup'}=0;
-    if (!parsargv::parse(\@_, 
-                         q^bymonth^, \$self->{'bymonth'},
-			 q^nogroup^, \$self->{'nogroup'},
-			 q^metadata/.*/^, \$datemeta,
-			 q^sort/.*/^, \$sortmeta,
-			 q^reverse_sort^, \$self->{'reverse_sort'},
-                         "allow_extra_options")) {
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
-    if (!defined $datemeta || $datemeta eq "") {
-	$datemeta = "Date";
-    }
-    $self->{'datemeta'} = $datemeta;
-
-    if (defined $sortmeta && $sortmeta ne "") {
-	$self->{'sortmeta'} = $sortmeta;
-    }
+    if (!defined $self->{"metadata"} || $self->{"metadata"} eq "") {
+	$self->{'metadata'} = "Date";
+    }
+    
     return bless $self, $class;
 }
@@ -128,10 +109,10 @@
 
     my $doc_OID = $doc_obj->get_OID();
-    my $date = $doc_obj->get_metadata_element ($doc_obj->get_top_section(), $self->{'datemeta'});
+    my $date = $doc_obj->get_metadata_element ($doc_obj->get_top_section(), $self->{'metadata'});
     
     my $sort_other = "";
-    if (defined $self->{'sortmeta'} && $self->{'sortmeta'} ne "") {
-	$sort_other = $doc_obj->get_metadata_element ($doc_obj->get_top_section(), $self->{'sortmeta'});
-	$sort_other = &sorttools::format_metadata_for_sorting($self->{'sortmeta'}, $sort_other, $doc_obj);
+    if (defined $self->{'sort'} && $self->{'sort'} ne "") {
+	$sort_other = $doc_obj->get_metadata_element ($doc_obj->get_top_section(), $self->{'sort'});
+	$sort_other = &sorttools::format_metadata_for_sorting($self->{'sort'}, $sort_other, $doc_obj);
     }
     # if this document doesn't contain Date element we won't 
@@ -143,5 +124,4 @@
 	} 
 
-	
 	$self->{'list'}->{$doc_OID} = "$date$sort_other";
     }
@@ -169,5 +149,5 @@
 			'Title'=>$title,
 			'contains'=>[],
-			'mdtype'=>$self->{'datemeta'});
+			'mdtype'=>$self->{'metadata'});
     $classifyinfo{'thistype'} = $thistype 
 	if defined $thistype && $thistype =~ /\w/;
